<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"] ?: array()) + array("_3cda3f34" . "ada928e4a" . "a39d4629c" . "5504aa" => base64_decode("aW50O" . "nJpZ2" . "h0cw=" . "="), "_ef2948c87ef38aab9226e41" . "189b29ca7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlcTpzdHI6Y29k" . "ZQ=="), "_938704c4c0169c" . "3804d4bd6aa9941" . "a76" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9iamVjdCBjb2RlIG5vdCBzcGVjaWZ" . "pZWQ="), "_dbbe14f567693a631f8a4" . "3b65af917ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tIGRhdGFi" . "YXNlOiBvYmplY3QgY29kZSBub3Qgc3BlY2lm" . "aWVk"), "_84718d828d2acc3c366f96b07e841f" . "6a" => base64_decode("YWNsLnNpbXBsZ" . "Q=="), "_0877a0b48cf424a0de57a453ce95e30" . "c" => base64_decode("aW50OnVzZX" . "JfaWQ="), "_b06968b9268deaf3b380bd0fe922b" . "453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYm" . "plY3RfY29kZSBlcTpzdHI6Y29kZSBBTkQgdXNlcl9p" . "ZD1pbnQ6dWlk"), "_a7ed4d7408bb9" . "9b87a09d89d421" . "2d5de" => base64_decode("c2ltcGx" . "lX2FjbA" . "=="), "_80fc2a45acd0150df87d1fb7" . "28940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2" . "NvZGUgZXE6c3RyOmNvZGUgQU5EIHVzZXJfaWQ9aW50OnVpZA=="), "_a8b22fedb27a11e0" . "7f5bb9a7c73608ea" => base64_decode("c3RyKDEwMCk6" . "b2JqZWN0X2Nv" . "ZGU="), "_27de5a45db71bf2405" . "8769b61b3975a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdC" . "Bjb2RlIG5vdCBzcGVjaWZpZWQ="), "_c95cbc316178" . "c97697a403f4d" . "9124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2" . "JqZWN0X2NvZGUgZXE6c3RyOmNvZGU="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_84718d828d2acc3c366f96b07e8" . "41f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_80fc2a45acd0150df87" . "d1fb728940a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_a7ed4d7408b" . "b99b87a09d89" . "d4212d5de"], [$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_a8b22fedb27a1" . "1e07f5bb9a7c73" . "608ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_0877a0b48cf424a0" . "de57a453ce95e30c"] => $user_id, $GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_3cda3f34ada928e4a" . "a39d4629c5504aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_b06968b9268deaf3b380bd0fe92" . "2b453"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_938704c4c0169c3804d4bd6aa" . "9941a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_c95cbc316178c9769" . "7a403f4d9124106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_27de5a45db71bf24058769b61b3975a" . "3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_dbbe14f567693a631f8a4" . "3b65af917ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_ef2948c" . "87ef38aa" . "b9226e41" . "189b29ca" . "7"], $acl->GetObjectCode());
    }
}